/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file    stm32f4xx_it.c
  * @brief   Interrupt Service Routines.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under Ultimate Liberty license
  * SLA0044, the "License"; You may not use this file except in compliance with
  * the License. You may obtain a copy of the License at:
  *                             www.st.com/SLA0044
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f4xx_it.h"
/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN TD */

/* USER CODE END TD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/* External variables --------------------------------------------------------*/
extern HCD_HandleTypeDef hhcd_USB_OTG_FS;
extern TIM_HandleTypeDef htim11;
/* USER CODE BEGIN EV */

/* USER CODE END EV */

/******************************************************************************/
/*           Cortex-M4 Processor Interruption and Exception Handlers          */
/******************************************************************************/
/**
  * @brief This function handles Non maskable interrupt.
  */
void NMI_Handler(void)
{
  /* USER CODE BEGIN NonMaskableInt_IRQn 0 */

  /* USER CODE END NonMaskableInt_IRQn 0 */
  /* USER CODE BEGIN NonMaskableInt_IRQn 1 */
  while (1)
  {
  }
  /* USER CODE END NonMaskableInt_IRQn 1 */
}

/**
  * @brief This function handles Hard fault interrupt.
  */
void HardFault_Handler(void)
{
  /* USER CODE BEGIN HardFault_IRQn 0 */

  /* USER CODE END HardFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_HardFault_IRQn 0 */
    /* USER CODE END W1_HardFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Memory management fault.
  */
void MemManage_Handler(void)
{
  /* USER CODE BEGIN MemoryManagement_IRQn 0 */

  /* USER CODE END MemoryManagement_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_MemoryManagement_IRQn 0 */
    /* USER CODE END W1_MemoryManagement_IRQn 0 */
  }
}

/**
  * @brief This function handles Pre-fetch fault, memory access fault.
  */
void BusFault_Handler(void)
{
  /* USER CODE BEGIN BusFault_IRQn 0 */

  /* USER CODE END BusFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_BusFault_IRQn 0 */
    /* USER CODE END W1_BusFault_IRQn 0 */
  }
}

/**
  * @brief This function handles Undefined instruction or illegal state.
  */
void UsageFault_Handler(void)
{
  /* USER CODE BEGIN UsageFault_IRQn 0 */

  /* USER CODE END UsageFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_UsageFault_IRQn 0 */
    /* USER CODE END W1_UsageFault_IRQn 0 */
  }
}

/**
  * @brief This function handles System service call via SWI instruction.
  */
void SVC_Handler(void)
{
  /* USER CODE BEGIN SVCall_IRQn 0 */

  /* USER CODE END SVCall_IRQn 0 */
  /* USER CODE BEGIN SVCall_IRQn 1 */

  /* USER CODE END SVCall_IRQn 1 */
}

/**
  * @brief This function handles Debug monitor.
  */
void DebugMon_Handler(void)
{
  /* USER CODE BEGIN DebugMonitor_IRQn 0 */

  /* USER CODE END DebugMonitor_IRQn 0 */
  /* USER CODE BEGIN DebugMonitor_IRQn 1 */

  /* USER CODE END DebugMonitor_IRQn 1 */
}

/**
  * @brief This function handles Pendable request for system service.
  */
void PendSV_Handler(void)
{
  /* USER CODE BEGIN PendSV_IRQn 0 */

  /* USER CODE END PendSV_IRQn 0 */
  /* USER CODE BEGIN PendSV_IRQn 1 */

  /* USER CODE END PendSV_IRQn 1 */
}

/**
  * @brief This function handles System tick timer.
  */
void SysTick_Handler(void)
{
  /* USER CODE BEGIN SysTick_IRQn 0 */

  /* USER CODE END SysTick_IRQn 0 */
  HAL_IncTick();
  /* USER CODE BEGIN SysTick_IRQn 1 */

  /* USER CODE END SysTick_IRQn 1 */
}

/******************************************************************************/
/* STM32F4xx Peripheral Interrupt Handlers                                    */
/* Add here the Interrupt Handlers for the used peripherals.                  */
/* For the available peripheral interrupt handler names,                      */
/* please refer to the startup file (startup_stm32f4xx.s).                    */
/******************************************************************************/

/**
  * @brief This function handles EXTI line0 interrupt.
  */
void EXTI0_IRQHandler(void)
{
  /* USER CODE BEGIN EXTI0_IRQn 0 */
	if(__HAL_GPIO_EXTI_GET_IT(MSX_A9_Pin) != RESET)
	{
	    GPIOA->BSRR = *msx_data9;
	    for(volatile uint32_t dt=0;dt<25;dt++);
	    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A9_Pin);;
	}
	GPIOA->BSRR = msx_reset;
  /* USER CODE END EXTI0_IRQn 0 */
  HAL_GPIO_EXTI_IRQHandler(MSX_A9_Pin);
  /* USER CODE BEGIN EXTI0_IRQn 1 */

  /* USER CODE END EXTI0_IRQn 1 */
}

/**
  * @brief This function handles EXTI line1 interrupt.
  */
void EXTI1_IRQHandler(void)
{
  /* USER CODE BEGIN EXTI1_IRQn 0 */
	if(__HAL_GPIO_EXTI_GET_IT(MSX_A10_Pin) != RESET)
	  {
	    GPIOA->BSRR = *msx_data10;
	    for(volatile uint32_t dt=0;dt<25;dt++);
	    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A10_Pin);
	}
	GPIOA->BSRR = msx_reset;
  /* USER CODE END EXTI1_IRQn 0 */
  HAL_GPIO_EXTI_IRQHandler(MSX_A10_Pin);
  /* USER CODE BEGIN EXTI1_IRQn 1 */

  /* USER CODE END EXTI1_IRQn 1 */
}

/**
  * @brief This function handles EXTI line[9:5] interrupts.
  */
void EXTI9_5_IRQHandler(void)
{
  /* USER CODE BEGIN EXTI9_5_IRQn 0 */
	if(__HAL_GPIO_EXTI_GET_IT(MSX_A0_Pin) != RESET)
	{
	    GPIOA->BSRR = *msx_data0;
	    for(volatile uint32_t dt=0;dt<25;dt++);
	    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A0_Pin);
	}
	else if(__HAL_GPIO_EXTI_GET_IT(MSX_A1_Pin) != RESET)
	{
	    GPIOA->BSRR = *msx_data1;
	    for(volatile uint32_t dt=0;dt<19;dt++);
	    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A1_Pin);
	}
	else if(__HAL_GPIO_EXTI_GET_IT(MSX_A2_Pin) != RESET)
	{
	    GPIOA->BSRR = *msx_data2;
	    for(volatile uint32_t dt=0;dt<19;dt++);
	    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A2_Pin);
	}
	else if(__HAL_GPIO_EXTI_GET_IT(MSX_A3_Pin) != RESET)
	{
	    GPIOA->BSRR = *msx_data3;
	    for(volatile uint32_t dt=0;dt<19;dt++);
	    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A3_Pin);
	}
	GPIOA->BSRR = msx_reset;

  /* USER CODE END EXTI9_5_IRQn 0 */
  HAL_GPIO_EXTI_IRQHandler(MSX_A0_Pin);
  HAL_GPIO_EXTI_IRQHandler(MSX_A1_Pin);
  HAL_GPIO_EXTI_IRQHandler(MSX_A2_Pin);
  HAL_GPIO_EXTI_IRQHandler(MSX_A3_Pin);
  /* USER CODE BEGIN EXTI9_5_IRQn 1 */

  /* USER CODE END EXTI9_5_IRQn 1 */
}

/**
  * @brief This function handles TIM1 trigger and commutation interrupts and TIM11 global interrupt.
  */
void TIM1_TRG_COM_TIM11_IRQHandler(void)
{
  /* USER CODE BEGIN TIM1_TRG_COM_TIM11_IRQn 0 */

  /* USER CODE END TIM1_TRG_COM_TIM11_IRQn 0 */
  HAL_TIM_IRQHandler(&htim11);
  /* USER CODE BEGIN TIM1_TRG_COM_TIM11_IRQn 1 */

  /* USER CODE END TIM1_TRG_COM_TIM11_IRQn 1 */
}

/**
  * @brief This function handles EXTI line[15:10] interrupts.
  */
void EXTI15_10_IRQHandler(void)
{
  /* USER CODE BEGIN EXTI15_10_IRQn 0 */
		if(__HAL_GPIO_EXTI_GET_IT(MSX_A4_Pin) != RESET)
		{
		    GPIOA->BSRR = *msx_data4;
		    for(volatile uint32_t dt=0;dt<22;dt++);
		    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A4_Pin);
		}
		else if(__HAL_GPIO_EXTI_GET_IT(MSX_A5_Pin) != RESET)
		{
		    GPIOA->BSRR = *msx_data5;
		    for(volatile uint32_t dt=0;dt<19;dt++);
		    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A5_Pin);
		}
		else if(__HAL_GPIO_EXTI_GET_IT(MSX_A6_Pin) != RESET)
		{
		    GPIOA->BSRR = *msx_data6;
		    for(volatile uint32_t dt=0;dt<19;dt++);
		    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A6_Pin);
		}
		else if(__HAL_GPIO_EXTI_GET_IT(MSX_A7_Pin) != RESET)
		{
		    GPIOA->BSRR = *msx_data7;
		    for(volatile uint32_t dt=0;dt<19;dt++);
		    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A7_Pin);
		}
		else if(__HAL_GPIO_EXTI_GET_IT(MSX_A8_Pin) != RESET)
		{
		    GPIOA->BSRR = *msx_data8;
		    for(volatile uint32_t dt=0;dt<19;dt++);
		    __HAL_GPIO_EXTI_CLEAR_IT(MSX_A8_Pin);
		}
		GPIOA->BSRR = msx_reset;
  /* USER CODE END EXTI15_10_IRQn 0 */
  HAL_GPIO_EXTI_IRQHandler(MSX_A4_Pin);
  HAL_GPIO_EXTI_IRQHandler(MSX_A5_Pin);
  HAL_GPIO_EXTI_IRQHandler(MSX_A6_Pin);
  HAL_GPIO_EXTI_IRQHandler(MSX_A7_Pin);
  HAL_GPIO_EXTI_IRQHandler(MSX_A8_Pin);
  /* USER CODE BEGIN EXTI15_10_IRQn 1 */

  /* USER CODE END EXTI15_10_IRQn 1 */
}

/**
  * @brief This function handles USB On The Go FS global interrupt.
  */
void OTG_FS_IRQHandler(void)
{
  /* USER CODE BEGIN OTG_FS_IRQn 0 */

  /* USER CODE END OTG_FS_IRQn 0 */
  HAL_HCD_IRQHandler(&hhcd_USB_OTG_FS);
  /* USER CODE BEGIN OTG_FS_IRQn 1 */

  /* USER CODE END OTG_FS_IRQn 1 */
}

/* USER CODE BEGIN 1 */

/* USER CODE END 1 */
